
{*****************************************}
{                                         }
{             FastReport v2.2             }
{             Report Designer             }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_Desgn;

interface

{$I FR_Vers.inc}

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Printers, ComCtrls,
  Menus {$IFDEF Delphi4}, ImgList {$ENDIF}, FR_Class, FR_Color,
  FR_Ctrls, FR_Dock;

type
  TSelectionType = (ssBand,ssMemo,ssOther,ssMultiple,ssClipboardFull);
  TSelectionStatus = set of TSelectionType;

  TfrDesigner = class(TComponent)  // fake component
  end;

  TFRDesignerForm = class(TfrReportDesigner)
    ScrollBox1: TScrollBox;
    StatusBar1: TStatusBar;
    frDock1: TfrDock;
    frDock2: TfrDock;
    frDock3: TfrDock;
    Popup1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    MainMenu1: TMainMenu;
    N4: TMenuItem;
    N7: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    N27: TMenuItem;
    N28: TMenuItem;
    N26: TMenuItem;
    N29: TMenuItem;
    N30: TMenuItem;
    N31: TMenuItem;
    N32: TMenuItem;
    N33: TMenuItem;
    Gr1: TMenuItem;
    Gr2: TMenuItem;
    N36: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    ImageList1: TImageList;
    Pan5: TMenuItem;
    N8: TMenuItem;
    Gr3: TMenuItem;
    Gr4: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N22: TMenuItem;
    N35: TMenuItem;
    ImageList2: TImageList;
    N38: TMenuItem;
    Pan6: TMenuItem;
    N39: TMenuItem;
    N40: TMenuItem;
    N42: TMenuItem;
    MastMenu: TMenuItem;
    Gr5: TMenuItem;
    N16: TMenuItem;
    Panel2: TfrToolBar;
    FileBtn1: TfrTBButton;
    FileBtn2: TfrTBButton;
    FileBtn3: TfrTBButton;
    FileBtn4: TfrTBButton;
    CutB: TfrTBButton;
    CopyB: TfrTBButton;
    PstB: TfrTBButton;
    ZB1: TfrTBButton;
    ZB2: TfrTBButton;
    SelAllB: TfrTBButton;
    PgB1: TfrTBButton;
    PgB2: TfrTBButton;
    PgB3: TfrTBButton;
    PrevB: TfrTBButton;
    NextB: TfrTBButton;
    GB1: TfrTBButton;
    GB2: TfrTBButton;
    ExitB: TfrTBButton;
    Panel3: TfrToolBar;
    AlB1: TfrTBButton;
    AlB2: TfrTBButton;
    AlB3: TfrTBButton;
    AlB4: TfrTBButton;
    AlB5: TfrTBButton;
    FnB1: TfrTBButton;
    FnB2: TfrTBButton;
    FnB3: TfrTBButton;
    ClB2: TfrTBButton;
    HlB1: TfrTBButton;
    AlB6: TfrTBButton;
    AlB7: TfrTBButton;
    Panel1: TfrToolBar;
    FrB1: TfrTBButton;
    FrB2: TfrTBButton;
    FrB3: TfrTBButton;
    FrB4: TfrTBButton;
    ClB1: TfrTBButton;
    ClB3: TfrTBButton;
    FrB5: TfrTBButton;
    FrB6: TfrTBButton;
    frTBSeparator1: TfrTBSeparator;
    frTBSeparator2: TfrTBSeparator;
    frTBSeparator3: TfrTBSeparator;
    frTBSeparator4: TfrTBSeparator;
    frTBSeparator5: TfrTBSeparator;
    frTBPanel1: TfrTBPanel;
    C3: TComboBox;
    C2: TComboBox;
    frTBPanel2: TfrTBPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    frTBSeparator6: TfrTBSeparator;
    frTBSeparator7: TfrTBSeparator;
    frTBSeparator8: TfrTBSeparator;
    frTBSeparator9: TfrTBSeparator;
    frTBSeparator10: TfrTBSeparator;
    frTBSeparator11: TfrTBSeparator;
    N37: TMenuItem;
    Pan2: TMenuItem;
    Pan3: TMenuItem;
    Pan1: TMenuItem;
    Pan4: TMenuItem;
    Panel4: TfrToolBar;
    OB1: TfrTBButton;
    OB2: TfrTBButton;
    OB3: TfrTBButton;
    OB4: TfrTBButton;
    OB5: TfrTBButton;
    frTBSeparator12: TfrTBSeparator;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PrevBClick(Sender: TObject);
    procedure NextBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DoClick(Sender: TObject);
    procedure ClB1Click(Sender: TObject);
    procedure GB1Click(Sender: TObject);
    procedure ZB1Click(Sender: TObject);
    procedure ZB2Click(Sender: TObject);
    procedure PgB1Click(Sender: TObject);
    procedure PgB2Click(Sender: TObject);
    procedure OB2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OB1Click(Sender: TObject);
    procedure CutBClick(Sender: TObject);
    procedure CopyBClick(Sender: TObject);
    procedure PstBClick(Sender: TObject);
    procedure SelAllBClick(Sender: TObject);
    procedure ExitBClick(Sender: TObject);
    procedure PgB3Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure Gr1Click(Sender: TObject);
    procedure Gr2Click(Sender: TObject);
    procedure GB2Click(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure FileBtn1Click(Sender: TObject);
    procedure FileBtn2Click(Sender: TObject);
    procedure FileBtn3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure Gr3Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure C2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect;
      State: TOwnerDrawState);
    procedure HlB1Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure FileBtn4Click(Sender: TObject);
    procedure N42Click(Sender: TObject);
    procedure Popup1Popup(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure N37Click(Sender: TObject);
    procedure Pan2Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
  private
    { Private declarations }
    FCurPage: Integer;
    CurDocName: String;
    ColorSelector: TColorSelector;
    FGridSize: Integer;
    FGridShow,FGridAlign: Boolean;
    procedure GetFontList;
    procedure SetCurPage(Value:Integer);
    procedure SetGridSize(Value:Integer);
    procedure SetGridShow(Value:Boolean);
    procedure SetGridAlign(Value:Boolean);
    function GetSelectionStatus: TSelectionStatus;
    procedure ShowPageNum;
    procedure SelectionChanged;
    procedure EnableControls;
    procedure ResetSelection;
    procedure DeleteObjects;
    procedure RemovePage(n:Integer);
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FillInspFields;
    function RectTypEnabled:Boolean;
    function FontTypEnabled:Boolean;
    function ZEnabled:Boolean;
    function CutEnabled:Boolean;
    function CopyEnabled:Boolean;
    function PasteEnabled:Boolean;
    function DelEnabled:Boolean;
    function EditEnabled:Boolean;
    procedure ColorSelected(Sender:TObject);
    procedure MoveObjects(dx,dy:Integer; Resize:Boolean);
    procedure SelectAll;
    procedure Unselect;
    procedure CutToClipboard;
    procedure CopyToClipboard;
    procedure SaveState;
    procedure RestoreState;
    procedure DoDrawText(AMenuItem: TMenuItem; ACanvas: TCanvas;
      const ACaption: string; var Rect: TRect; Selected: Boolean; Flags: Longint);
    procedure MeasureItem(AMenuItem: TMenuItem; ACanvas: TCanvas;
      var AWidth, AHeight: Integer);
    procedure DrawItem(AMenuItem: TMenuItem; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
  public
    { Public declarations }
    procedure AfterLanguageLoaded; override;
    procedure WndProc(var Message: TMessage); override;
    procedure RegisterObject(ButtonBmp:TBitmap; const ButtonHint:String;
      ButtonTag:Integer); override;
    procedure PopupNotify(Sender: TfrView); override;
    procedure ShowMemoEditor;
    procedure ShowEditor;
    procedure RedrawPage;
    procedure OnModify(Item:Integer);
    property CurPage: Integer read FCurPage write SetCurPage;
    property SelStatus: TSelectionStatus read GetSelectionStatus;
    property GridSize: Integer read FGridSize write SetGridSize;
    property ShowGrid: Boolean read FGridShow write SetGridShow;
    property GridAlign: Boolean read FGridAlign write SetGridAlign;
  end;

  TPreview = class(TPanel)
  private
    property Canvas;
    procedure MDown(Sender:TObject; Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
    procedure MUp(Sender:TObject; Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
    procedure MMove(Sender:TObject; Shift:TShiftState; X,Y:Integer);
    procedure DClick(Sender:TObject);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner:TComponent); override;
    procedure SetPage;
    procedure GetMultipleSelected;
    procedure NormalizeRect(var r:TRect);
  end;

function frGetTopSelected: Integer;
procedure frSetGlyph(Color:TColor; sb:TfrSpeedButton; n:Integer);
procedure frRegisterTool(MenuCaption:String; OnClick:TNotifyEvent);
function frCheckBand(b:TfrBandType): Boolean;

var
  DesignerForm: TfrDesignerForm;
  Preview: TPreview;
  FirstSelected: TfrView;
  SelNum: Integer;                  // number of objects currently selected


implementation

{$R *.DFM}
{$R CoolMenu.RES}

uses
  FR_Pgopt, FR_GEdit, FR_Edit, FR_Templ, FR_Newrp, FR_Insp,
  FR_Prntr, FR_Hilit, FR_Flds, FR_Dopt, FR_Align, FR_Ev_ed,
  FR_BndEd, FR_BTyp, FR_Utils, FR_GrpEd, Registry;

type
  TDesignerDrawMode = (dmAll,dmSelection,dmShape);
  TSplitInfo = record
    SplRect: TRect;
    SplX: Integer;
    View1,View2: TfrView;
  end;

  TMenuItemInfo = class(TObject)
  private
    MenuItem: TMenuItem;
    Btn: TfrSpeedButton;
  end;

procedure DrawFocusRect(Canvas:TCanvas; Rect:TRect); forward;
procedure DrawHSplitter(Canvas:TCanvas; Rect:TRect); forward;
procedure DrawSelection(t:TfrView); forward;
procedure DrawShape(t:TfrView); forward;
procedure Draw(N:Integer; ClipRgn:HRGN); forward;
procedure DrawPage(DrawMode:TDesignerDrawMode); forward;
function GetUnusedBand: TfrBandType; forward;
procedure SendBandsToDown; forward;
procedure Unselect; forward;
procedure ClearClipBoard; forward;
function Objects:TList; forward;
procedure GetRegion; forward;

var Down,                          // mouse button was pressed
    Moved,                         // mouse was moved (with pressed btn)
    DFlag,                         // was double click
    RFlag,                         // selecting objects by framing
    OIFlag,                        // object inspector flag
    MRFlag,                        // several objects was selected
    ObjRepeat: Boolean;            // was pressed Shift + Insert Object
    ClipBd: TList;                 // clipboard
    Mode: (mdInsert,mdSelect);     // current mode
    LastX,LastY: Integer;          // here stored last mouse coords
    OldRect,OldRect1: TRect;       // object rect after mouse was clicked
    CT: (ctNone,ct1,ct2,ct3,ct4);  // current mouse cursor (sizing arrows)
    BPanel,RPanel: TPanel;         // special panels (see TDesignForm.Create)
    Busy: Boolean;                 // busy flag. need!
    RightBottom: Integer;
    fld: Array[0..4] of String[100];
    ShapeMode: (smFrame,smBar);    // show selection: frame or bar
    GridBitmap: TBitmap;           // for drawing grid in design time
    LastFontName: String;
    LastFontSize: Integer;
    LeftTop: TPoint;
    ClrButton: TfrSpeedButton;
    FirstChange,FirstBandMove: Boolean;
    SplitInfo: TSplitInfo;
    ClipRgn: HRGN;
    MenuItems: TList;
    ItemWidths: TStringList;
    MaxItemWidth,MaxShortCutWidth: Integer;



function FindMenuItem(AMenuItem:TMenuItem): TMenuItemInfo;
var i: Integer;
begin
  Result := nil;
  for i := 0 to MenuItems.Count-1 do
    if TMenuItemInfo(MenuItems[i]).MenuItem = AMenuItem then
    begin
      Result := TMenuItemInfo(MenuItems[i]);
      Exit;
    end;
end;

procedure SetMenuItemBitmap(AMenuItem:TMenuItem; ABtn:TfrSpeedButton);
var m: TMenuItemInfo;
begin
  m := FindMenuItem(AMenuItem);
  if m = nil then
  begin
    m := TMenuItemInfo.Create;
    m.MenuItem := AMenuItem;
    MenuItems.Add(m);
  end;
  m.Btn := ABtn;
  ModifyMenu(AMenuItem.Parent.Handle, AMenuItem.MenuIndex,
    MF_BYPOSITION + MF_OWNERDRAW, AMenuItem.Command, nil);
end;

procedure FillMenuItems(MenuItem:TMenuItem);
var i: Integer;
    m: TMenuItem;
begin
  for i := 0 to MenuItem.Count-1 do
  begin
    m := MenuItem.Items[i];
    SetMenuItemBitmap(m, nil);
    if m.Count > 0 then FillMenuItems(m);
  end;
end;

procedure DeleteMenuItems(MenuItem:TMenuItem);
var i,j: Integer;
    m: TMenuItem;
begin
  for i := 0 to MenuItem.Count-1 do
  begin
    m := MenuItem.Items[i];
    for j := 0 to MenuItems.Count-1 do
    if TMenuItemInfo(MenuItems[j]).MenuItem = m then
    begin
      TMenuItemInfo(MenuItems[j]).Free;
      MenuItems.Delete(j);
      break;
    end;
  end;
end;

procedure frRegisterTool(MenuCaption:String; OnClick:TNotifyEvent);
var m: TMenuItem;
begin
  m := TMenuItem.Create(DesignerForm.MastMenu);
  m.Caption := MenuCaption;
  m.OnClick := OnClick;
  DesignerForm.MastMenu.Enabled := True;
  DesignerForm.MastMenu.Add(m);
end;

{--------------------------------------------------}
constructor TPreview.Create(AOwner:TComponent);
begin
  Inherited Create(AOwner);
  Parent := AOwner as TWinControl;
  BevelInner := bvNone;
  BevelOuter := bvNone;
  Color  := clWhite;
  BorderStyle := bsNone;
  OnMouseDown := MDown;
  OnMouseUp := MUp;
  OnMouseMove := MMove;
  OnDblClick := DClick;
end;

procedure TPreview.SetPage;
var Pgw,Pgh: Integer;
begin
  Pgw := frDesigner.Page.PrnInfo.Pgw;
  Pgh := frDesigner.Page.PrnInfo.Pgh;
  if Pgw > Parent.Width then
    SetBounds(10,10,Pgw,Pgh) else
    SetBounds((Parent.Width-Pgw) div 2,10,Pgw,Pgh);
  BPanel.Top := Top+Height+10;
  RPanel.Left := Left+Width+10;
end;

procedure TPreview.Paint;
begin
  Draw(10000, 0);
  DesignerForm.ShowPageNum;
end;

procedure TPreview.GetMultipleSelected;
var i,j,k: Integer;
    t: TfrView;
begin
  j := 0; k := 0;
  LeftTop := Point(10000,10000);
  RightBottom := -1;
  MRFlag := False;
  if SelNum > 1 then                  {find right-bottom element}
  begin
    for i := 0 to Objects.Count-1 do
    begin
      t := Objects[i];
      if t.Selected then
      begin
        t.OriginalRect := Rect(t.x,t.y,t.dx,t.dy);
        if (t.x+t.dx > j) or ((t.x+t.dx = j) and (t.y+t.dy > k)) then
        begin
          j := t.x+t.dx;
          k := t.y+t.dy;
          RightBottom := i;
        end;
        if t.x < LeftTop.x then LeftTop.x := t.x;
        if t.y < LeftTop.y then LeftTop.y := t.y;
      end;
    end;
    t := Objects[RightBottom];
    OldRect := Rect(LeftTop.x,LeftTop.y,t.x+t.dx,t.y+t.dy);
    OldRect1 := OldRect;
    MRFlag := True;
  end;
end;

procedure TPreview.NormalizeRect(var r:TRect);
var i: Integer;
begin
  with r do
  begin
    if Left > Right then begin i := Left; Left := Right; Right := i end;
    if Top > Bottom then begin i := Top; Top := Bottom; Bottom := i end;
  end;
end;

procedure TPreview.MDown(Sender:TObject; Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
var i: Integer;
    f,DontChange,v: Boolean;
    t: TfrView;
    Rgn: HRGN;
    p: TPoint;
begin
  if DFlag then
  begin
    DFlag := False;
    Exit;
  end;
  DrawPage(dmSelection);
  Down := True;
  DontChange := False;
  if Button = mbLeft then
    if (ssCtrl in Shift) or (Cursor = crCross) then
    begin
      RFlag := True;
      OldRect := Rect(x,y,x,y);
      Unselect;
      SelNum := 0;
      RightBottom := -1;
      MRFlag := False;
      FirstSelected := nil;
      Exit;
    end;
  if Cursor = crDefault then
  begin
    f := False;
    for i := Objects.Count-1 downto 0 do
    begin
      t := Objects[i];
      Rgn := t.GetClipRgn(rtNormal);
      v := PtInRegion(Rgn, X, Y);
      DeleteObject(Rgn);
      if v then
      begin
        if ssShift in Shift then
        begin
          t.Selected := not t.Selected;
          if t.Selected then Inc(SelNum) else Dec(SelNum);
        end
        else
        begin
          if not t.Selected then
          begin
            Unselect;
            SelNum := 1;
            t.Selected := True;
          end
          else DontChange := True;
        end;
        if SelNum = 0 then FirstSelected := nil
        else if SelNum = 1 then FirstSelected := t
        else if FirstSelected <> nil then
          if not FirstSelected.Selected then FirstSelected := nil;
        f := True;
        break;
      end;
    end;
    if not f then
    begin
      Unselect;
      SelNum := 0;
      FirstSelected := nil;
      if Button = mbLeft then
      begin
        RFlag := True;
        OldRect := Rect(x,y,x,y);
        Exit;
      end;
    end;
    GetMultipleSelected;
    if not DontChange then DesignerForm.SelectionChanged;
  end;
  if SelNum = 0 then
  begin // reset multiple selection
    RightBottom := -1;
    MRFlag := False;
  end;
  LastX := x;
  LastY := y;
  Moved := False;
  FirstChange := True;
  FirstBandMove := True;
  if Button = mbRight then
  begin
    DrawPage(dmSelection);
    Down := False;
    GetCursorPos(p);
    DesignerForm.Popup1Popup(nil);
    TrackPopupMenu(DesignerForm.Popup1.Handle,
      TPM_LEFTALIGN or TPM_RIGHTBUTTON, p.X, p.Y, 0, DesignerForm.Handle, nil);
  end
  else
    DrawPage(dmShape);
end;

procedure TPreview.MUp(Sender:TObject; Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
var i,k,dx,dy: Integer;
    t: TfrView;
    nx,ny,x1,x2,y1,y2: Double;
procedure AddObject(ot:Byte);
begin
  Objects.Add(frCreateObject(ot,''));
  t := Objects.Last;
end;
procedure CreateMemo;
begin
  Objects.Add(TfrMemoView.Create);
  t := Objects.Last;
end;
procedure CreateSection;
begin
  BandTypesForm := TBandTypesForm.Create(nil);
  BandTypesForm.ShowModal;
  Objects.Add(TfrBandView.Create);
  t := Objects.Last;
  t.FrameTyp := BandTypesForm.SelectedTyp;
  BandTypesForm.Free;
  SendBandsToDown;
end;
procedure CreateSubReport;
begin
  Objects.Add(TfrSubReportView.Create);
  t := Objects.Last;
  (t as TfrSubReportView).SubPage := CurReport.Pages.Count;
  with DesignerForm do
  begin
    ResetSelection;
    CurReport.Pages.Add;
    ShowPageNum;
    NextB.Enabled := True;
  end;
end;

begin
  if Button <> mbLeft then Exit;
  Down := False;
  DrawPage(dmShape);
 //inserting a new object
  if Cursor = crCross then
  begin
    DrawFocusRect(Canvas,OldRect);
    NormalizeRect(OldRect);
    if DesignerForm.GridAlign then
    with OldRect do
    begin
      Left := Left - Left mod DesignerForm.GridSize;
      Top := Top - Top mod DesignerForm.GridSize;
      Right := Right - Right mod DesignerForm.GridSize;
      Bottom := Bottom - Bottom mod DesignerForm.GridSize;
    end;
    with OldRect do
      if (Left = Right) or (Top = Bottom) then
        OldRect := Rect(Left,Top,Left+40,Top+40);
    RFlag := False;
    with DesignerForm.Panel4 do
    for i := 0 to ControlCount-1 do
      if Controls[i] is TfrSpeedButton then
      with Controls[i] as TfrSpeedButton do
        if Down then
        begin
          if Tag = gtBand then
            if GetUnusedBand <> btNone then
              CreateSection
            else
              Exit
          else if Tag = gtSubReport then
            CreateSubReport
          else if Tag >= gtAddIn then
          begin
            k := Tag - gtAddIn;
            Objects.Add(frCreateObject(gtAddIn,frAddIns[k].ClassRef.ClassName));
            t := Objects.Last;
          end
          else
            AddObject(Tag);
          break;
        end;
    Unselect;
    t.x := OldRect.Left; t.y := OldRect.Top;
    t.dx := OldRect.Right-OldRect.Left; t.dy := OldRect.Bottom-OldRect.Top;
    t.Selected := True;
    t.FrameWidth := 1;
    if t.Typ <> gtBand then
      t.FrameTyp := 15;
    if t is TfrMemoView then
      with t as TfrMemoView do
      begin
        FontName := LastFontName;
        FontSize := LastFontSize;
      end;
    SelNum := 1;
    if t.Typ = gtBand then
      Draw(10000, t.GetClipRgn(rtExtended))
    else
    begin
      t.Draw(Canvas);
      DrawSelection(t);
    end;
    if not ObjRepeat then DesignerForm.OB1.Down := True;
    DesignerForm.SelectionChanged;
    Exit;
  end;
 //calculating which objects contains in frame (if user select it with mouse+Ctrl key)
  if RFlag then
  begin
    DrawFocusRect(Canvas,OldRect);
    RFlag := False;
    NormalizeRect(OldRect);
    for i := 0 to Objects.Count-1 do
    begin
      t := Objects[i];
      with OldRect do
      if not ((t.x > Right) or (t.x+t.dx < Left) or
              (t.y > Bottom) or (t.y+t.dy < Top)) then
      begin
        t.Selected := True;
        Inc(SelNum);
      end;
    end;
    GetMultipleSelected;
    DesignerForm.SelectionChanged;
    DrawPage(dmSelection);
    Exit;
  end;
// splitting
  if Moved and MRFlag and (Cursor = crHSplit) then
  begin
    with SplitInfo do
    begin
      dx := SplRect.Left-SplX;
      if (View1.dx+dx > 0) and (View2.dx-dx > 0) then
      begin
        Inc(View1.dx,dx);
        Inc(View2.x,dx);
        Dec(View2.dx,dx);
      end;
    end;
    GetMultipleSelected;
    Draw(frGetTopSelected, ClipRgn);
    Exit;
  end;
// resizing several objects
  if Moved and MRFlag and (Cursor <> crDefault) then
  begin
    DrawFocusRect(Canvas,OldRect);
    nx := (OldRect.Right - OldRect.Left) / (OldRect1.Right - OldRect1.Left);
    ny := (OldRect.Bottom - OldRect.Top) / (OldRect1.Bottom - OldRect1.Top);
    for i := 0 to Objects.Count-1 do
    begin
      t := Objects[i];
      if t.Selected then
      begin
        x1 := (t.OriginalRect.Left-LeftTop.x)*nx;
        x2 := t.OriginalRect.Right*nx;
        dx := Round(x1+x2)-(Round(x1)+Round(x2));
        t.x := LeftTop.x+Round(x1); t.dx := Round(x2)+dx;

        y1 := (t.OriginalRect.Top-LeftTop.y)*ny;
        y2 := t.OriginalRect.Bottom*ny;
        dy := Round(y1+y2)-(Round(y1)+Round(y2));
        t.y := LeftTop.y+Round(y1); t.dy := Round(y2)+dy;
      end;
    end;
    Draw(frGetTopSelected, ClipRgn);
    Exit;
  end;
// redrawing all moved or resized objects
  if not Moved then DrawPage(dmSelection);
  if (SelNum >= 1) and Moved then
    if SelNum > 1 then
    begin
      Draw(frGetTopSelected, ClipRgn);
      GetMultipleSelected;
    end
    else
    begin
      t := Objects[frGetTopSelected];
      if t.dx < 0 then
      begin
        t.dx := -t.dx;
        t.x := t.x - t.dx;
      end;
      if t.dy < 0 then
      begin
        t.dy := -t.dy;
        t.y := t.y - t.dy;
      end;
      if Cursor <> crDefault then t.Resized;
      Draw(frGetTopSelected, ClipRgn);
      DesignerForm.FillInspFields;
      InspForm.ItemsChanged;
    end;
  Moved := False;
  CT := ctNone;
end;

procedure TPreview.MMove(Sender:TObject; Shift:TShiftState; X,Y:Integer);
var i,j,kx,ky,w: Integer;
    t,t1,Bnd: TfrView;
function Cont(px,py,x,y:Integer):Boolean;
begin
  Result := (x >= px-w) and (x <= px+w+1) and (y >= py-w) and (y <= py+w+1);
end;
function GridCheck:Boolean;
begin
  with DesignerForm do
  begin
    Result := (kx >= GridSize) or (kx <= -GridSize) or
              (ky >= GridSize) or (ky <= -GridSize);
    if Result then
    begin
      kx := kx - kx mod GridSize;
      ky := ky - ky mod GridSize;
    end;
  end;
end;

begin
  Moved := True;
  w := 2;
  if FirstChange and Down and not RFlag then GetRegion;

  if not Down then
    if DesignerForm.OB1.Down then
    begin
      Mode := mdSelect;
      Cursor := crDefault;
    end
    else
    begin
      Mode := mdInsert;
      Cursor := crCross;
    end;
 // cursor shapes
  if not Down and (SelNum = 1) and (Mode = mdSelect) then
  begin
    t := Objects[frGetTopSelected];
    if Cont(t.x,t.y,x,y) or Cont(t.x+t.dx,t.y+t.dy,x,y) then
      Cursor := crSizeNWSE
    else if Cont(t.x+t.dx,t.y,x,y) or Cont(t.x,t.y+t.dy,x,y)then
      Cursor := crSizeNESW
    else if Cont(t.x+t.dx div 2,t.y,x,y) or Cont(t.x+t.dx div 2,t.y+t.dy,x,y) then
      Cursor := crSizeNS
    else if Cont(t.x,t.y+t.dy div 2,x,y) or Cont(t.x+t.dx,t.y+t.dy div 2,x,y) then
      Cursor := crSizeWE
    else
      Cursor := crDefault;
  end;
  // selecting a lot of objects
  if RFlag then
  begin
    DrawFocusRect(Canvas,OldRect);
    OldRect := Rect(OldRect.Left,OldRect.Top,x,y);
    DrawFocusRect(Canvas,OldRect);
    Exit;
  end;
  // check for multiple selected objects - right-bottom corner
  if not Down and (SelNum > 1) and (Mode = mdSelect) then
  begin
    t := Objects[RightBottom];
    if Cont(t.x+t.dx,t.y+t.dy,x,y) then
      Cursor := crSizeNWSE
  end;
  // split checking
  if not Down and (SelNum > 1) and (Mode = mdSelect) then
  begin
    for i := 0 to Objects.Count-1 do
    begin
      t := Objects[i];
      if (t.Typ <> gtBand) and t.Selected then
        if (x >= t.x) and (x <= t.x+t.dx) and (y >= t.y) and (y <= t.y+t.dy) then
        begin
          for j := 0 to Objects.Count-1 do
          begin
            t1 := Objects[j];
            if (t1.Typ <> gtBand) and (t1 <> t) and t1.Selected then
              if ((t.x = t1.x+t1.dx) and ((x >= t.x) and (x <= t.x+2))) or
              ((t1.x = t.x+t.dx) and ((x >= t1.x-2) and (x <= t.x))) then
              begin
                Cursor := crHSplit;
                with SplitInfo do
                begin
                  SplRect := Rect(x,t.y,x,t.y+t.dy);
                  if t.x = t1.x+t1.dx then
                  begin
                    SplX := t.x;
                    View1 := t1;
                    View2 := t;
                  end
                  else
                  begin
                    SplX := t1.x;
                    View1 := t;
                    View2 := t1;
                  end;
                  SplRect.Left := SplX;
                  SplRect.Right := SplX;
                end;
              end;
          end;
        end;
    end;
  end;
  // splitting
  if Down and MRFlag and (Mode = mdSelect) and (Cursor = crHSplit) then
  begin
    kx := x - LastX;
    ky := 0;
    if DesignerForm.GridAlign and not GridCheck then Exit;
    with SplitInfo do
    begin
      DrawHSplitter(Canvas,SplRect);
      SplRect := Rect(SplRect.Left+kx,SplRect.Top,SplRect.Right+kx,SplRect.Bottom);
      DrawHSplitter(Canvas,SplRect);
    end;
    LastX := x - ((x - LastX) - kx);
    Exit;
  end;
  // sizing several objects
  if Down and MRFlag and (Mode = mdSelect) and (Cursor <> crDefault) then
  begin
    kx := x - LastX;
    ky := y - LastY;
    if DesignerForm.GridAlign and not GridCheck then Exit;
    DrawFocusRect(Canvas,OldRect);
    OldRect := Rect(OldRect.Left,OldRect.Top,OldRect.Right+kx,OldRect.Bottom+ky);
    DrawFocusRect(Canvas,OldRect);
    LastX := x - ((x - LastX) - kx);
    LastY := y - ((y - LastY) - ky);
    DesignerForm.StatusBar1.Repaint;
    Exit;
  end;
  // moving
  if Down and (Mode = mdSelect) and (SelNum >= 1) and (Cursor = crDefault) then
  begin
    kx := x - LastX;
    ky := y - LastY;
    if DesignerForm.GridAlign and not GridCheck then Exit;
    if FirstBandMove and (SelNum = 1) and ((kx <> 0) or (ky <> 0)) and
      not (ssAlt in Shift) then
      if TfrView(Objects[frGetTopSelected]).Typ = gtBand then
      begin
        Bnd := Objects[frGetTopSelected];
        for i := 0 to Objects.Count-1 do
        begin
          t := Objects[i];
          if t.Typ <> gtBand then
            if (t.x >= Bnd.x) and (t.x+t.dx <= Bnd.x+Bnd.dx) and
               (t.y >= Bnd.y) and (t.y+t.dy <= Bnd.y+Bnd.dy) then
            begin
              t.Selected := True;
              Inc(SelNum);
            end;
        end;
        GetMultipleSelected;
      end;
    FirstBandMove := False;
    DrawPage(dmShape);
    for i := 0 to Objects.Count-1 do
    begin
      t := Objects[i];
      if not t.Selected then continue;
      t.x := t.x + kx;
      t.y := t.y + ky;
    end;
    DrawPage(dmShape);
    LastX := x - ((x - LastX) - kx);
    LastY := y - ((y - LastY) - ky);
    DesignerForm.StatusBar1.Repaint;
  end;
 // resizing
  if Down and (Mode = mdSelect) and (SelNum = 1) and (Cursor <> crDefault) then
  begin
    kx := x - LastX;
    ky := y - LastY;
    if DesignerForm.GridAlign and not GridCheck then Exit;
    DrawPage(dmShape);
    t := Objects[frGetTopSelected];
    w := 3;
    if Cursor = crSizeNWSE then
      if (CT = ct1) or Cont(t.x,t.y,LastX,LastY) then
      begin
        t.x := t.x + kx;
        t.dx := t.dx - kx;
        t.y := t.y + ky;
        t.dy := t.dy - ky;
        CT := ct1;
      end
      else
      begin
        t.dx := t.dx + kx;
        t.dy := t.dy + ky;
      end;
    if Cursor = crSizeNESW then
      if (CT = ct2) or Cont(t.x+t.dx,t.y,LastX,LastY) then
      begin
        t.y := t.y + ky;
        t.dx := t.dx + kx;
        t.dy := t.dy - ky;
        CT := ct2;
      end
      else
      begin
        t.x := t.x + kx;
        t.dx := t.dx - kx;
        t.dy := t.dy + ky;
      end;
    if Cursor = crSizeWE then
      if (CT = ct3) or Cont(t.x,t.y+t.dy div 2,LastX,LastY) then
      begin
        t.x := t.x + kx;
        t.dx := t.dx - kx;
        CT := ct3;
      end
      else
        t.dx := t.dx + kx;
    if Cursor = crSizeNS then
      if (CT = ct4) or Cont(t.x+t.dx div 2,t.y,LastX,LastY) then
      begin
        t.y := t.y + ky;
        t.dy := t.dy - ky;
        CT := ct4;
      end
      else
        t.dy := t.dy + ky;
    DrawPage(dmShape);
    LastX := x - ((x - LastX) - kx);
    LastY := y - ((y - LastY) - ky);
    DesignerForm.StatusBar1.Repaint;
  end;
end;

procedure TPreview.DClick(Sender:TObject);
begin
  Down := False;
  if SelNum <> 1 then Exit;
  DesignerForm.ShowEditor;
  DFlag := True;
end;

{-----------------------------------------------------------------------------}
procedure BDown(SB:TfrSpeedButton);
begin
  SB.Down := True;
end;

procedure BUp(SB:TfrSpeedButton);
begin
  SB.Down := False;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  DesignerForm.C2.Items.AddObject(StrPas(LogFont.lfFaceName), TObject(FontType));
  Result := 1;
end;

procedure TFRDesignerForm.GetFontList;
var DC: HDC;
begin
  C2.Items.Clear;
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(Self));
  ReleaseDC(0,DC);
  LastFontName := C2.Items[0];
  C2.Items.Add('');
  if C2.Items.IndexOf('Arial') <> -1 then
    LastFontName := 'Arial'
  else if C2.Items.IndexOf('Arial Cyr') <> -1 then
    LastFontName := 'Arial Cyr';
  LastFontSize := 10;
end;


procedure TFRDesignerForm.FormCreate(Sender: TObject);
var i: Integer;
begin
  Busy := True;
  // these invisible panels are added to set scroll range to
  // 0..Preview.Width+10 and 0..Preview.Height+10
  BPanel := TPanel.Create(ScrollBox1);
  BPanel.Parent := ScrollBox1;
  BPanel.Height := 1; BPanel.Left := 0; BPanel.Top := ScrollBox1.Height;
  BPanel.Color := ScrollBox1.Color;

  RPanel := TPanel.Create(ScrollBox1);
  RPanel.Parent := ScrollBox1;
  RPanel.Width := 1; RPanel.Left := ScrollBox1.Width; RPanel.Top := 0;
  RPanel.Color := ScrollBox1.Color;

  Preview := TPreview.Create(ScrollBox1);
  Preview.PopupMenu := Popup1;
  Preview.ShowHint := True;

  ColorSelector := TColorSelector.Create(Self);
  ColorSelector.OnColorSelected := ColorSelected;

  GridBitmap := TBitmap.Create;
  with GridBitmap do
  begin
    Width := 8; Height := 8;
  end;

  for i := 0 to frAddInsCount-1 do
  with frAddIns[i] do
    RegisterObject(ButtonBmp,ButtonHint,Integer(gtAddIn) + i);

  OIFlag := False;
  InspForm := TInspForm.Create(nil);
  AlignForm := TAlignForm.Create(nil);
  EditorForm := TEditorForm.Create(nil);
end;

procedure TFRDesignerForm.FormShow(Sender: TObject);
begin
  Busy := True;
  DocMode := dmDesigning;
  GetFontList;
  C2.Perform(CB_SETDROPPEDWIDTH,170,0);
  with InspForm do
  begin
    ClearItems;
    Items.AddObject('Left',TProp.Create(@fld[0],csEdit,nil));
    Items.AddObject('Top',TProp.Create(@fld[1],csEdit,nil));
    Items.AddObject('Width',TProp.Create(@fld[2],csEdit,nil));
    Items.AddObject('Height',TProp.Create(@fld[3],csEdit,nil));
    Items.AddObject('Memo',TProp.Create(@fld[4],csDefEditor,EditorForm));
    OnModify := Self.OnModify;
  end;
  CurPage := 0; // this cause TPreview sizing
  Unselect;
  Down := False; DFlag := False; RFlag := False;
  EnableControls;
  Preview.Cursor := crDefault; CT := ctNone;
  BDown(OB1);
  frSetGlyph(0,ClB1,1); frSetGlyph(0,ClB2,0); frSetGlyph(0,ClB3,2);
  ColorSelector.Hide;
  FillInspFields;
  InspForm.ItemsChanged;
  RestoreState;
end;

procedure TFRDesignerForm.FormHide(Sender: TObject);
begin
  SaveState;
end;

procedure TFRDesignerForm.FormDestroy(Sender: TObject);
var i: Integer;
begin
  for i := 0 to MenuItems.Count-1 do
    TMenuItemInfo(MenuItems[i]).Free;
  MenuItems.Free;
  ItemWidths.Free;
  Preview.Free;
  BPanel.Free;
  RPanel.Free;
  GridBitmap.Free;
  ColorSelector.Free;
  InspForm.Free;
  AlignForm.Free;
  EditorForm.Free;
end;

procedure TFRDesignerForm.FormResize(Sender: TObject);
var p: TPoint;
begin
  if csDestroying in ComponentState then Exit;
  with ScrollBox1 do
  begin
    HorzScrollBar.Position := 0;
    VertScrollBar.Position := 0;
  end;
  p := ClientToScreen(Point(ClientWidth-152,75));
  FillInspFields;
  InspForm.ItemsChanged;
  OIFlag := True;
  Preview.SetPage;
end;

procedure TFRDesignerForm.AfterLanguageLoaded;
begin
  MaxItemWidth := 0; MaxShortCutWidth := 0;
  MenuItems := TList.Create;
  ItemWidths := TStringlist.Create;
  FillMenuItems(N4);
  FillMenuItems(N7);
  FillMenuItems(N9);

  SetMenuItemBitmap(N23, FileBtn1);
  SetMenuItemBitmap(N19, FileBtn2);
  SetMenuItemBitmap(N20, FileBtn3);
  SetMenuItemBitmap(N39, FileBtn4);
  SetMenuItemBitmap(N10, ExitB);

  SetMenuItemBitmap(N11, CutB);
  SetMenuItemBitmap(N12, CopyB);
  SetMenuItemBitmap(N13, PstB);
  SetMenuItemBitmap(N28, SelAllB);
  SetMenuItemBitmap(N29, PgB1);
  SetMenuItemBitmap(N30, PgB2);
  SetMenuItemBitmap(N32, ZB1);
  SetMenuItemBitmap(N33, ZB2);
end;

procedure TFRDesignerForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin // for best view
  with Msg.MinMaxInfo^ do
  begin
    ptMaxSize.x := Screen.Width;
    ptMaxSize.y := Screen.Height;
    ptMaxPosition.x := 0;
    ptMaxPosition.y := 0;
  end;
end;

procedure TFRDesignerForm.SetCurPage(Value:Integer);
begin // setting curpage and do all manipulation
  FCurPage := Value;
  Page := CurReport.Pages[CurPage];
  ScrollBox1.VertScrollBar.Position := 0;
  ScrollBox1.HorzScrollBar.Position := 0;
  Preview.SetPage;
  ShowPageNum;
  ResetSelection;
  SendBandsToDown;
  Preview.Repaint;
  PrevB.Enabled := CurPage > 0;
  NextB.Enabled := CurPage < CurReport.Pages.Count-1;
end;

procedure TFRDesignerForm.SetGridSize(Value:Integer);
begin
  if FGridSize = Value then Exit;
  FGridSize := Value;
  RedrawPage;
end;

procedure TFRDesignerForm.SetGridShow(Value:Boolean);
begin
  if FGridShow = Value then Exit;
  FGridShow := Value;
  GB1.Down := Value;
  RedrawPage;
end;

procedure TFRDesignerForm.SetGridAlign(Value:Boolean);
begin
  if FGridAlign = Value then Exit;
  GB2.Down := Value;
  FGridAlign := Value;
end;

procedure TFRDesignerForm.PopupNotify(Sender:TfrView);
begin
  DrawPage(dmSelection);
  Draw(frGetTopSelected, 0);
end;

procedure TFRDesignerForm.RegisterObject(ButtonBmp:TBitmap;
  const ButtonHint:String; ButtonTag:Integer);
var b: TfrTBButton;
begin
  b := TfrTBButton.Create(Self);
  b.Parent := Panel4;
  b.Glyph := ButtonBmp;
  b.Hint := ButtonHint;
  b.GroupIndex := 1;
  b.Flat := True;
  b.SetBounds(0,1000,22,22);
  b.Tag := ButtonTag;
end;

procedure TFRDesignerForm.RemovePage(n:Integer);
begin
  with CurReport do
    if (n >= 0) and (n < Pages.Count) then
      if Pages.Count = 1 then
        Pages[n].Clear else
        CurReport.Pages.Delete(n);
end;

procedure TFRDesignerForm.CutToClipboard;
var i: Integer;
    t: TfrView;
begin
  ClearClipBoard;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
    begin
      ClipBd.Add(frCreateObject(t.Typ,t.ClassName));
      TfrView(ClipBd.Last).Assign(t);
    end;
  end;
  for i := Objects.Count-1 downto 0 do
  begin
    t := Objects[i];
    if t.Selected then Page.Delete(i);
  end;
  SelNum := 0;
end;

procedure TFRDesignerForm.CopyToClipboard;
var i: Integer;
    t: TfrView;
begin
  ClearClipBoard;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
    begin
      ClipBd.Add(frCreateObject(t.Typ,t.ClassName));
      TfrView(ClipBd.Last).Assign(t);
    end;
  end;
end;

procedure TFRDesignerForm.SelectAll;
var i: Integer;
begin
  SelNum := 0;
  for i := 0 to Objects.Count-1 do
  begin
    TfrView(Objects[i]).Selected := True;
    Inc(SelNum);
  end;
end;

procedure TFRDesignerForm.Unselect;
var i: Integer;
begin
  SelNum := 0;
  for i := 0 to Objects.Count-1 do
    TfrView(Objects[i]).Selected := False;
end;

procedure TFRDesignerForm.ShowPageNum;
var N: Integer;
begin
  N := CurReport.Pages.Count;
  if N = 0 then N := 1;
  StatusBar1.Panels[0].Text := frLoadStr('SPg') + ' ' +
    IntToStr(CurPage+1) + '/' + IntToStr(N);
end;

procedure TFRDesignerForm.ResetSelection;
begin
  Unselect;
  SelNum := 0;
  EnableControls;
  FillInspFields;
  InspForm.ItemsChanged;
end;

procedure TFRDesignerForm.RedrawPage;
begin
  Draw(10000,0);
end;

procedure TFRDesignerForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var StepX,StepY: Integer;
    i,tx,ty,tx1,ty1,d,d1: Integer;
    t,t1: TfrView;
begin
  StepX := 0; StepY := 0;
  if (Key = vk_Return) and (ActiveControl = C3) then
  begin
    Key := 0;
    DoClick(C3);
  end;
  if (Key = vk_Return) and (ActiveControl = Edit1) then
  begin
    Key := 0;
    DoClick(UpDown1);
  end;
  if (Key = vk_Delete) and DelEnabled then
  begin
    DeleteObjects;
    Key := 0;
  end;
  if (Key = vk_Return) and EditEnabled then
  begin
    if ssCtrl in Shift then
      ShowMemoEditor else
      ShowEditor;
  end;
  if CutEnabled then
    if (Key = vk_Delete) and (ssShift in Shift) then CutBClick(Self);
  if CopyEnabled then
    if (Key = vk_Insert) and (ssCtrl in Shift) then CopyBClick(Self);
  if PasteEnabled then
    if (Key = vk_Insert) and (ssShift in Shift) then PstBClick(Self);
  if Key = vk_Prior then
    with ScrollBox1.VertScrollBar do
    begin
      Position := Position - 200;
      Key := 0;
    end;
  if Key = vk_Next then
    with ScrollBox1.VertScrollBar do
    begin
      Position := Position + 200;
      Key := 0;
    end;
  if SelNum > 0 then
  begin
    if Key = vk_Up then StepY := -1
    else if Key = vk_Down then StepY := 1
    else if Key = vk_Left then StepX := -1
    else if Key = vk_Right then StepX := 1;
    if (StepX <> 0) or (StepY <> 0) then
    begin
      if ssCtrl in Shift then
        MoveObjects(StepX, StepY, False)
      else if ssShift in Shift then
        MoveObjects(StepX, StepY, True)
      else if SelNum = 1 then
      begin
        t := Objects[frGetTopSelected];
        tx := t.x; ty := t.y; tx1 := t.x + t.dx; ty1 := t.y + t.dy;
        d := 10000; t1 := nil;
        for i := 0 to Objects.Count-1 do
        begin
          t := Objects[i];
          if not t.Selected and (t.Typ <> gtBand) then
          begin
            d1 := 10000;
            if StepX <> 0 then
            begin
              if t.y+t.dy < ty then
                d1 := ty - (t.y+t.dy)
              else if t.y > ty1 then
                d1 := t.y - ty1
              else if (t.y <= ty) and (t.y+t.dy >= ty1) then
                d1 := 0
              else
                d1 := t.y - ty;
              if ((t.x <= tx) and (StepX = 1)) or
                 ((t.x+t.dx >= tx1) and (StepX = -1)) then
                d1 := 10000;
              if StepX = 1 then
              begin
                if t.x > tx1 then
                  d1 := d1 + t.x-tx1
                else
                  d1 := d1 + t.x-tx;
              end
              else
              begin
                if t.x+t.dx < tx then
                  d1 := d1 + tx-(t.x+t.dx)
                else
                  d1 := d1 + tx1-(t.x+t.dx);
              end;
            end
            else if StepY <> 0 then
            begin
              if t.x+t.dx < tx then
                d1 := tx - (t.x+t.dx)
              else if t.x > tx1 then
                d1 := t.x - tx1
              else if (t.x <= tx) and (t.x+t.dx >= tx1) then
                d1 := 0
              else
                d1 := t.x - tx;
              if ((t.y <= ty) and (StepY = 1)) or
                 ((t.y+t.dy >= ty1) and (StepY = -1)) then
                d1 := 10000;
              if StepY = 1 then
              begin
                if t.y > ty1 then
                  d1 := d1 + t.y-ty1
                else
                  d1 := d1 + t.y-ty;
              end
              else
              begin
                if t.y+t.dy < ty then
                  d1 := d1 + ty-(t.y+t.dy)
                else
                  d1 := d1 + ty1-(t.y+t.dy);
              end;
            end;
            if d1 < d then
            begin
              d := d1;
              t1 := t;
            end;
          end;
        end;
        if t1 <> nil then
        begin
          DrawPage(dmSelection);
          Unselect;
          SelNum := 1;
          t1.Selected := True;
          DrawPage(dmSelection);
          SelectionChanged;
        end;
      end;
    end;
  end;
end;

procedure TFRDesignerForm.MoveObjects(dx,dy:Integer; Resize:Boolean);
var i: Integer;
    t: TfrView;
begin
  GetRegion;
  DrawPage(dmSelection);
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      if Resize then
      begin
        Inc(t.dx,dx); Inc(t.dy,dy);
      end
      else
      begin
        Inc(t.x,dx); Inc(t.y,dy);
      end;
  end;
  FillInspFields;
  InspForm.ItemsChanged;
  StatusBar1.Repaint;
  Preview.GetMultipleSelected;
  Draw(frGetTopSelected, ClipRgn);
end;

procedure TFRDesignerForm.DeleteObjects;
var i: Integer;
    t: TfrView;
begin
  GetRegion;
  DrawPage(dmSelection);
  for i := Objects.Count-1 downto 0 do
  begin
    t := Objects[i];
    if t.Selected then Page.Delete(i);
  end;
  ResetSelection;
  FirstSelected := nil;
  Draw(10000, ClipRgn);
end;

function TFRDesignerForm.GetSelectionStatus: TSelectionStatus;
var t: TfrView;
begin
  Result := [];
  if SelNum = 1 then
  begin
    t := Objects[frGetTopSelected];
    if t.Typ = gtBand then
      Result := [ssBand]
    else if t is TfrMemoView then
      Result := [ssMemo] else
      Result := [ssOther];
  end
  else if SelNum > 1 then
    Result := [ssMultiple];
  if ClipBd.Count > 0 then
    Result := Result + [ssClipboardFull];
end;

function TFRDesignerForm.RectTypEnabled:Boolean;
begin
  Result := [ssMemo,ssOther,ssMultiple] * SelStatus <> [];
end;

function TFRDesignerForm.FontTypEnabled:Boolean;
begin
  Result := [ssMemo,ssMultiple] * SelStatus <> [];
end;

function TFRDesignerForm.ZEnabled:Boolean;
begin
  Result := [ssBand,ssMemo,ssOther,ssMultiple] * SelStatus <> [];
end;

function TFRDesignerForm.CutEnabled:Boolean;
begin
  Result := [ssBand,ssMemo,ssOther,ssMultiple] * SelStatus <> [];
end;

function TFRDesignerForm.CopyEnabled:Boolean;
begin
  Result := [ssBand,ssMemo,ssOther,ssMultiple] * SelStatus <> [];
end;

function TFRDesignerForm.PasteEnabled:Boolean;
begin
  Result := ssClipboardFull in SelStatus;
end;

function TFRDesignerForm.DelEnabled:Boolean;
begin
  Result := [ssBand,ssMemo,ssOther,ssMultiple] * SelStatus <> [];
end;

function TFRDesignerForm.EditEnabled:Boolean;
begin
  Result := [ssBand,ssMemo,ssOther] * SelStatus <> [];
end;

procedure TFRDesignerForm.EnableControls;
procedure SetEnabled(const Ar:Array of TObject; en:Boolean);
var i: Integer;
begin
  for i := Low(Ar) to High(Ar) do
    if Ar[i] is TControl then
      (Ar[i] as TControl).Enabled := en
    else if Ar[i] is TMenuItem then
      (Ar[i] as TMenuItem).Enabled := en;
end;
begin
  SetEnabled([FrB1,FrB2,FrB3,FrB4,FrB5,FrB6,ClB1,ClB3,UpDown1,Edit1],
    RectTypEnabled);
  SetEnabled([ClB2,C2,C3,FnB1,FnB2,FnB3,AlB1,AlB2,AlB3,AlB4,AlB5,AlB6,AlB7,HlB1],
    FontTypEnabled);
  SetEnabled([ZB1,ZB2,N32,N33],ZEnabled);
  SetEnabled([CutB,N11,N2],CutEnabled);
  SetEnabled([CopyB,N12,N1],CopyEnabled);
  SetEnabled([PstB,N13,N3],PasteEnabled);
  SetEnabled([N27,N5],DelEnabled);
  SetEnabled([N36,N6],EditEnabled);
  InspForm.EnableItem(4,EditEnabled);
  StatusBar1.Repaint;
end;

procedure TFRDesignerForm.SelectionChanged;
var t: TfrView;
    n: Integer;
begin
  Busy := True;
  ColorSelector.Hide;
  EnableControls;
  if SelNum = 1 then
  begin
    t := Objects[frGetTopSelected];
    if t.Typ <> gtBand then
    with t do
    begin
      FrB1.Down := (FrameTyp and $8) <> 0;
      FrB2.Down := (FrameTyp and $4) <> 0;
      FrB3.Down := (FrameTyp and $2) <> 0;
      FrB4.Down := (FrameTyp and $1) <> 0;
      UpDown1.Position := FrameWidth;
      frSetGlyph(FillColor,ClB1,1);
      frSetGlyph(FrameColor,ClB3,2);
      if t is TfrMemoView then
      with t as TfrMemoView do
      begin
        frSetGlyph(FontColor,ClB2,0);
        C2.ItemIndex := C2.Items.IndexOf(FontName);
        n := C3.Items.IndexOf(IntToStr(FontSize));
        if n <> -1 then
          C3.ItemIndex := n else
          C3.Text := IntToStr(FontSize);
        FnB1.Down := (FontStyle and $2) <> 0;
        FnB2.Down := (FontStyle and $1) <> 0;
        FnB3.Down := (FontStyle and $4) <> 0;
        AlB4.Down := (Adjust and $4) <> 0;
        AlB5.Down := (Adjust and $18) = $8;
        AlB6.Down := (Adjust and $18) = 0;
        AlB7.Down := (Adjust and $18) = $10;
        case (Adjust and $3) of
          0: BDown(AlB1);
          1: BDown(AlB2);
          2: BDown(AlB3);
        end;
      end;
    end;
  end
  else if SelNum > 1 then
  begin
    BUp(FrB1); BUp(FrB2); BUp(FrB3); BUp(FrB4);
    frSetGlyph(0,ClB1,1); UpDown1.Position := 1; C2.ItemIndex := 0; C3.ItemIndex := 5;
    BUp(FnB1); BUp(FnB2); BUp(FnB3);
    BDown(AlB1); BUp(AlB4); BUp(AlB5);
  end;
  Busy := False;
  FillInspFields;
  InspForm.ItemsChanged;
  ActiveControl := nil;
end;

procedure SetBit(var w:Word; e:Boolean; m:Integer);
begin
  if e then w := w or m
  else w := w and not m;
end;

procedure TFRDesignerForm.DoClick(Sender: TObject);
var i,b: Integer;
    DRect: TRect;
    t: TfrView;
begin
  if Busy then Exit;
  DrawPage(dmSelection);
  GetRegion;
  b := (Sender as TControl).Tag;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected and ((t.Typ <> gtBand) or (b = 16)) then
    with t do
    begin
      if t is TfrMemoView then
      with t as TfrMemoView do
        case b of
          7: if C2.ItemIndex <> 0 then
             begin
               FontName := C2.Text;
               LastFontName := FontName;
             end;
          8: begin
               FontSize := StrToInt(C3.Text);
               LastFontSize := FontSize;
             end;
          9: SetBit(FontStyle,FnB1.Down,2);
         10: SetBit(FontStyle,FnB2.Down,1);
         11..13: Adjust := (Adjust and $FC) + (b-11);
         14: Adjust := (Adjust and $FB)+ Word(AlB4.Down)*4;
         15: Adjust := (Adjust and $E7) + Word(AlB5.Down)*8 + Word(AlB7.Down)*$10;
         17: FontColor := ColorSelector.Color;
         18: SetBit(FontStyle,FnB3.Down,4);
        end;
      case b of
        1:
         begin
           SetBit(FrameTyp,FrB1.Down,8);
           DRect := Rect(t.x-10,t.y-10,t.x+t.dx+10,t.y+10)
         end;
        2:
         begin
           SetBit(FrameTyp,FrB2.Down,4);
           DRect := Rect(t.x-10,t.y-10,t.x+10,t.y+t.dy+10)
         end;
        3:
         begin
           SetBit(FrameTyp,FrB3.Down,2);
           DRect := Rect(t.x-10,t.y+t.dy-10,t.x+t.dx+10,t.y+t.dy+10)
         end;
        4:
         begin
           SetBit(FrameTyp,FrB4.Down,1);
           DRect := Rect(t.x+t.dx-10,t.y-10,t.x+t.dx+10,t.y+t.dy+10)
         end;
       20: FrameTyp := FrameTyp or $F;
       21: FrameTyp := FrameTyp and not $F;
        5: FillColor := ColorSelector.Color;
        6: FrameWidth := UpDown1.Position;
       19: FrameColor := ColorSelector.Color;
      end;
    end;
  end;
  Draw(frGetTopSelected, ClipRgn);
  ActiveControl := nil;
  if b in [20,21] then SelectionChanged;
end;

procedure TFRDesignerForm.HlB1Click(Sender: TObject);
var t: TfrMemoView;
begin
  t := Objects[frGetTopSelected];
  HilightForm := THilightForm.Create(nil);
  with HilightForm do
  begin
    FontColor := t.Highlight.FontColor;
    FillColor := t.Highlight.FillColor;
    CB1.Checked := (t.Highlight.FontStyle and $2) <> 0;
    CB2.Checked := (t.Highlight.FontStyle and $1) <> 0;
    CB3.Checked := (t.Highlight.FontStyle and $4) <> 0;
    if ShowModal = mrOk then
    begin
      t.Highlight.FontColor := FontColor;
      t.Highlight.FillColor := FillColor;
      SetBit(t.Highlight.FontStyle,CB1.Checked,2);
      SetBit(t.Highlight.FontStyle,CB2.Checked,1);
      SetBit(t.Highlight.FontStyle,CB3.Checked,4);
    end;
  end;
  HilightForm.Free;
end;

procedure TFRDesignerForm.FillInspFields;
var t: TfrView;
begin
  fld[0] := ''; fld[1] := ''; fld[2] := '';
  fld[3] := ''; fld[4] := '';
  InspForm.V := nil;
  if SelNum = 1 then
  begin
    t := Objects[frGetTopSelected];
    InspForm.V := t;
    fld[0] := IntToStr(t.x); fld[1] := IntToStr(t.y);
    fld[2] := IntToStr(t.dx); fld[3] := IntToStr(t.dy);
  end;
  InspForm.HideProperties := SelNum = 0;
end;

procedure TFRDesignerForm.OnModify(Item:Integer);
var t: TfrView;
    i,k: Integer;
begin
  k := 0;
  if Item < 4 then k := StrToInt(fld[Item]);
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
    with t do
      case Item of
        0: x := k;
        1: y := k;
        2: dx := k;
        3: dy := k;
      end;
  end;
  RedrawPage;
end;

procedure TFRDesignerForm.ClB1Click(Sender: TObject);
var p: TPoint;
begin
  with (Sender as TControl) do
    p := Self.ScreenToClient(Parent.ClientToScreen(Point(Left, Top)));
  if ColorSelector.Left = p.X then
    ColorSelector.Visible := not ColorSelector.Visible
  else
  begin
    ColorSelector.Left := p.X;
    ColorSelector.Top := p.Y + 26;
    ColorSelector.Visible := True;
  end;
  ClrButton := Sender as TfrSpeedButton;
  ColorSelector.Color := ClrButton.Glyph.Canvas.Pixels[2,14];
end;

procedure TFRDesignerForm.ColorSelected(Sender:TObject);
var n: Integer;
begin
  n := 0;
  if ClrButton = ClB1 then
    n := 1
  else if ClrButton = ClB3 then
    n := 2;
  frSetGlyph(ColorSelector.Color,ClrButton,n);
  DoClick(ClrButton);
end;

procedure TFRDesignerForm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var t: TfrView;
    s: String;
    nx,ny: Double;
begin
  with StatusBar.Canvas do
  begin
    FillRect(Rect);
    ImageList1.Draw(StatusBar.Canvas,Rect.Left+2,Rect.Top,0);
    ImageList1.Draw(StatusBar.Canvas,Rect.Left+72,Rect.Top,1);
    if SelNum = 1 then
    begin
      t := Objects[frGetTopSelected];
      TextOut(Rect.Left+20,Rect.Top+1,IntToStr(t.x) + ',' + IntToStr(t.y));
      TextOut(Rect.Left+90,Rect.Top+1,IntToStr(t.dx) + ',' + IntToStr(t.dy));
      if (t.Typ = gtPicture) then
        with t as TfrPictureView do
        if (Picture.Graphic <> nil) and not Picture.Graphic.Empty then
        begin
          s := IntToStr(dx * 100 div Picture.Width) + ',' +
               IntToStr(dy * 100 div Picture.Height);
          TextOut(Rect.Left+150,Rect.Top+1,'% ' + s);
        end;
    end
    else if (SelNum > 0) and MRFlag then
    begin
      nx := (OldRect.Right - OldRect.Left) / (OldRect1.Right - OldRect1.Left);
      ny := (OldRect.Bottom - OldRect.Top) / (OldRect1.Bottom - OldRect1.Top);
      s := IntToStr(Round(nx * 100)) + ',' + IntToStr(Round(ny * 100));
      TextOut(Rect.Left+150,Rect.Top+1,'% ' + s);
    end;
  end;
end;

procedure TFRDesignerForm.C2DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with C2.Canvas do
  begin
    FillRect(Rect);
    if (Integer(C2.Items.Objects[Index]) and TRUETYPE_FONTTYPE) <> 0 then
      ImageList2.Draw(C2.Canvas,Rect.Left,Rect.Top+1,0);
    TextOut(Rect.Left+20,Rect.Top+1,C2.Items[Index]);
  end;
end;

procedure TFRDesignerForm.ShowMemoEditor;
begin
  with EditorForm do
  begin
    View := Objects[frGetTopSelected];
    if ShowEditor = mrOk then
    begin
      DrawPage(dmSelection);
      Draw(frGetTopSelected, View.GetClipRgn(rtExtended));
    end;
  end;
  ActiveControl := nil;
end;

procedure TFRDesignerForm.ShowEditor;
var t: TfrView;
    i: Integer;
    bt: TfrBandType;
begin
  t := Objects[frGetTopSelected];
  if t.Typ = gtMemo then
    ShowMemoEditor
  else if t.Typ = gtPicture then
  begin
    GEditorForm := TGEditorForm.Create(nil);
    with GEditorForm do
    begin
      Image1.Picture.Assign((t as TfrPictureView).Picture);
      if ShowModal = mrOk then
      begin
        DrawPage(dmSelection);
        (t as TfrPictureView).Picture.Assign(Image1.Picture);
        Draw(frGetTopSelected, t.GetClipRgn(rtExtended));
      end;
    end;
    GEditorForm.Free;
    StatusBar1.Repaint;
  end
  else if t.Typ = gtBand then
  begin
    DrawPage(dmSelection);
    bt := TfrBandType(t.FrameTyp);
    if bt in [btMasterData,btDetailData,btSubDetailData,btColumnData] then
    begin
      BandEditorForm := TBandEditorForm.Create(nil);
      BandEditorForm.ShowEditor(t);
      BandEditorForm.Free;
      Draw(frGetTopSelected, t.GetClipRgn(rtExtended));
    end
    else if bt = btGroupHeader then
    begin
      GroupEditorForm := TGroupEditorForm.Create(nil);
      GroupEditorForm.ShowEditor(t);
      GroupEditorForm.Free;
      Draw(frGetTopSelected, t.GetClipRgn(rtExtended));
    end;
  end
  else if t.Typ = gtSubReport then
  begin
    CurPage := (t as TfrSubReportView).SubPage;
  end
  else if t.Typ = gtAddIn then
  begin
    for i := 0 to frAddInsCount-1 do
      if frAddIns[i].ClassRef.ClassName = t.ClassName then
      begin
        if frAddIns[i].EditorForm <> nil then
        begin
          DrawPage(dmSelection);
          frAddIns[i].EditorForm.ShowEditor(t);
          Draw(frGetTopSelected, t.GetClipRgn(rtExtended));
        end
        else
          ShowMemoEditor;
        break;
      end;
  end;
  ActiveControl := nil;
end;

procedure TFRDesignerForm.ZB1Click(Sender: TObject);   // go up
var i,j,n: Integer;
    t: TfrView;
begin
  n := Objects.Count; i := 0; j := 0;
  while j < n do
  begin
    t := Objects[i];
    if t.Selected then
    begin
      Objects.Delete(i);
      Objects.Add(t);
    end else Inc(i);
    Inc(j);
  end;
  SendBandsToDown;
  RedrawPage;
end;

procedure TFRDesignerForm.ZB2Click(Sender: TObject);    // go down
var t: TfrView;
    i,j,n: Integer;
begin
  n := Objects.Count; j := 0; i := n-1;
  while j < n do
  begin
    t := Objects[i];
    if t.Selected then
    begin
      Objects.Delete(i);
      Objects.Insert(0,t);
    end else Dec(i);
    Inc(j);
  end;
  SendBandsToDown;
  RedrawPage;
end;

procedure TFRDesignerForm.PgB1Click(Sender: TObject);
begin             // add page
  ResetSelection;
  CurReport.Pages.Add;
  CurPage := CurReport.Pages.Count-1;
end;

procedure TFRDesignerForm.PgB2Click(Sender: TObject);
begin                   // remove page
  if MessageBox(0, PChar(frLoadStr('SRemovePg')),
    PChar(frLoadStr('SConfirm')), mb_IconQuestion+mb_YesNo) = mrYes then
  begin
    RemovePage(CurPage);
    CurPage := 0;
  end;
end;

procedure TFRDesignerForm.PrevBClick(Sender: TObject);
begin
  CurPage := CurPage-1;
end;

procedure TFRDesignerForm.NextBClick(Sender: TObject);
begin
  CurPage := CurPage+1;
end;

procedure TFRDesignerForm.OB1Click(Sender: TObject);
begin
  ObjRepeat := False;
end;

procedure TFRDesignerForm.OB2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ObjRepeat := ssShift in Shift;
end;

procedure TFRDesignerForm.CutBClick(Sender: TObject); //cut
begin
  CutToClipboard;
  FirstSelected := nil;
  EnableControls;
  RedrawPage;
end;

procedure TFRDesignerForm.CopyBClick(Sender: TObject); //copy
begin
  CopyToClipboard;
  EnableControls;
end;

procedure TFRDesignerForm.PstBClick(Sender: TObject); //paste
var i,minx,miny: Integer;
    t,t1: TfrView;
begin
  Unselect;
  SelNum := 0;
  minx := 32767; miny := 32767;
  with ClipBd do
  for i := 0 to Count-1 do
  begin
    t := Items[i];
    if t.x < minx then minx := t.x;
    if t.y < miny then miny := t.y;
  end;
  for i := 0 to ClipBd.Count-1 do
  begin
    t := ClipBd.Items[i];
    if (t.Typ = gtBand) and frCheckBand(TfrBandType(t.FrameTyp)) then
      continue;
    t.x := t.x - minx;
    if Preview.Top < 0 then
      t.y := t.y - miny + ((-Preview.Top) - (-Preview.Top) mod 4)
    else
      t.y := t.y - miny;
    Inc(SelNum);
    Objects.Add(frCreateObject(t.Typ,t.ClassName));
    t1 := Objects.Last;
    t1.Assign(t);
  end;
  SelectionChanged;
  SendBandsToDown;
  Preview.GetMultipleSelected;
  RedrawPage;
end;

procedure TFRDesignerForm.SelAllBClick(Sender: TObject); // select all
begin
  DrawPage(dmSelection);
  SelectAll;
  Preview.GetMultipleSelected;
  DrawPage(dmSelection);
  SelectionChanged;
end;

procedure TFRDesignerForm.ExitBClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;


procedure TFRDesignerForm.N5Click(Sender: TObject);
begin // popup delete command
  DeleteObjects;
end;

procedure TFRDesignerForm.N6Click(Sender: TObject);
begin // popup edit command
  ShowEditor;
end;

procedure TFRDesignerForm.FileBtn1Click(Sender: TObject);
begin // create new
  CurReport.Pages.Clear;
  CurReport.Pages.Add;
  CurPage := 0;
end;

procedure TFRDesignerForm.N23Click(Sender: TObject);
begin // create new from template
  TemplForm := TTemplForm.Create(nil);
  with TemplForm do
  if ShowModal = mrOk then
  begin
    CurReport.LoadTemplate(TemplName,nil,nil,True);
    CurDocName := ChangeFileExt(TemplName,'.frf');
    CurPage := 0; // do all
  end;
  TemplForm.Free;
end;

procedure TFRDesignerForm.FileBtn2Click(Sender: TObject);
begin // open
  OpenDialog1.Filter := frLoadStr('SFormFile') + ' (*.frf)|*.frf';
  if OpenDialog1.Execute then
  begin
    CurDocName := ExtractFileName(OpenDialog1.FileName);
    CurReport.LoadFromFile(OpenDialog1.FileName);
    CurPage := 0; // do all
  end;
end;

procedure TFRDesignerForm.FileBtn3Click(Sender: TObject);
var s: String;
begin // save as
  with SaveDialog1 do
  begin
    Filter := frLoadStr('SFormFile') + ' (*.frf)|*.frf|' +
              frLoadStr('STemplFile') + ' (*.frt)|*.frt';
    FileName := CurDocName;
    FilterIndex := 1;
    if Execute then
      if FilterIndex = 1 then
      begin
        s := '.frf';
        CurReport.SaveToFile(ChangeFileExt(FileName,s));
      end
      else
      begin
        s := ExtractFileName(ChangeFileExt(FileName,'.frt'));
        if CurReport.TemplateDir <> '' then
          s := CurReport.TemplateDir + '\' + s;
        TemplNewForm := TTemplNewForm.Create(nil);
        with TemplNewForm do
        if ShowModal = mrOk then
          CurReport.SaveTemplate(s,Memo1.Lines,Image1.Picture.Bitmap);
        TemplNewForm.Free;
      end;
  end;
end;

procedure TFRDesignerForm.FileBtn4Click(Sender: TObject);
var v1,v2: Boolean;
begin
  v1 := InspForm.Visible;
  v2 := AlignForm.Visible;
  InspForm.Hide;
  AlignForm.Hide;
  Application.ProcessMessages;
  CurReport.ShowReport;
  InspForm.Visible := v1;
  AlignForm.Visible := v2;
  SetFocus;
  DocMode := dmDesigning;
  CurPage := 0;
end;

procedure TFRDesignerForm.N42Click(Sender: TObject);
begin // var editor
  ShowEvEditor(CurReport,nil);
end;

procedure TFRDesignerForm.PgB3Click(Sender: TObject);
var w,h,p: Integer;
begin // page setup
  PgoptForm := TPgoptForm.Create(nil);
  with PgoptForm, Page do
  begin
    CB1.Checked := PrintToPrevPage;
    CB2.Checked := PHonFirst;
    CB3.Checked := PFonLast;
    CB4.Checked := CHCopy;
    CB5.Checked := not UseMargins;
    if pgOr = poPortrait then
      RB1.Checked := True
    else
      RB2.Checked := True;
    ComB1.Items := Prn.PaperNames;
    ComB1.ItemIndex := Prn.GetArrayPos(pgSize);
    E1.Text := ''; E2.Text := '';
    if pgSize = $100 then
    begin
      E1.Text := IntToStr(pgWidth div 10); E2.Text := IntToStr(pgHeight div 10);
    end;
    E3.Text := IntToStr(pgMargins.Left*5 div 18);
    E4.Text := IntToStr(pgMargins.Top*5 div 18);
    E5.Text := IntToStr(pgMargins.Right*5 div 18);
    E6.Text := IntToStr(pgMargins.Bottom*5 div 18);
    E7.Text := IntToStr(ColGap*5 div 18);
    UpDown1.Position := ColCount;
    UpDown1.Associate := Edit1;
    if ShowModal = mrOk then
    begin
      PrintToPrevPage :=  CB1.Checked;
      PHonFirst := CB2.Checked;
      PFonLast := CB3.Checked;
      CHCopy := CB4.Checked;
      UseMargins := not CB5.Checked;
      if RB1.Checked then
        pgOr := poPortrait
      else
        pgOr := poLandscape;
      p := Prn.PaperSizes[ComB1.ItemIndex];
      w := 0; h := 0;
      if p = $100 then
        try
          w := StrToInt(E1.Text)*10; h := StrToInt(E2.Text)*10;
        except
          on exception do p := 9; // A4
        end;
      try
        pgMargins := Rect(StrToInt(E3.Text)*18 div 5,StrToInt(E4.Text)*18 div 5,
          StrToInt(E5.Text)*18 div 5,StrToInt(E6.Text)*18 div 5);
        ColGap := StrToInt(E7.Text)*18 div 5;
      except
        on exception do
        begin
          pgMargins := Rect(0,0,0,0);
          ColGap := 0;
        end;
      end;
      ColCount := UpDown1.Position;
      ChangePaper(p,w,h,pgOr);
      CurPage := CurPage; // for repaint and other
    end;
  end;
  PgoptForm.Free;
end;

procedure TFRDesignerForm.N8Click(Sender: TObject);
begin // printer setup
  DocOptForm := TDocOptForm.Create(nil);
  with DocOptForm do
  begin
    CB1.Checked := not CurReport.PrintToDefault;
    CB2.Checked := CurReport.DoublePass;
    if ShowModal = mrOk then
    begin
      CurReport.PrintToDefault := not CB1.Checked;
      CurReport.DoublePass := CB2.Checked;
      CurReport.ChangePrinter(Prn.PrinterIndex,ComB1.ItemIndex);
    end;
    CurPage := CurPage;
    Free;
  end;
end;

procedure TFRDesignerForm.N14Click(Sender: TObject);
begin // grid menu
  Gr1.Checked := ShowGrid;
  Gr2.Checked := GridAlign;
  case GridSize of
    4: Gr3.Checked := True;
    8: Gr4.Checked := True;
    18: Gr5.Checked := True;
  end;
end;

procedure TFRDesignerForm.Gr1Click(Sender: TObject);
begin // Grid menu command
  with Sender as TMenuItem do
  begin
    Checked := not Checked;
    ShowGrid := Checked;
  end;
end;

procedure TFRDesignerForm.Gr2Click(Sender: TObject);
begin // Grid-align menu command
  with Sender as TMenuItem do
  begin
    Checked := not Checked;
    GridAlign := Checked;
  end;
end;

procedure TFRDesignerForm.Gr3Click(Sender: TObject);
begin // grid size
  with Sender as TMenuItem do
  begin
    Checked := True;
    GridSize := Tag;
  end;
end;

procedure TFRDesignerForm.GB1Click(Sender: TObject);
begin
  ShowGrid := GB1.Down;
end;

procedure TFRDesignerForm.GB2Click(Sender: TObject);
begin
  GridAlign := GB2.Down;
end;

procedure TFRDesignerForm.N22Click(Sender: TObject);
begin // selection shape
  (Sender as TMenuItem).Checked := True;
  if N22.Checked then
    ShapeMode := smFrame else
    ShapeMode := smBar;
end;

procedure TFRDesignerForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  DoClick(UpDown1);
end;

procedure TFRDesignerForm.Popup1Popup(Sender: TObject);
var i: Integer;
    t,t1: TfrView;
    fl: Boolean;
begin
  DeleteMenuItems(N2.Parent);
  EnableControls;
  while Popup1.Items.Count > 7 do
    Popup1.Items.Delete(7);
  if SelNum = 1 then
    TfrView(Objects[frGetTopSelected]).DefinePopupMenu(Popup1)
  else if SelNum > 1 then
  begin
    t := Objects[frGetTopSelected];
    fl := True;
    for i := 0 to Objects.Count-1 do
    begin
      t1 := Objects[i];
      if t1.Selected then
        if not (((t is TfrMemoView) and (t1 is TfrMemoView)) or
           ((t.Typ <> gtAddIn) and (t.Typ = t1.Typ)) or
           ((t.Typ = gtAddIn) and (t.ClassName = t1.ClassName))) then
        begin
          fl := False;
          break;
        end;
    end;
    if fl then t.DefinePopupMenu(Popup1);
  end;

  FillMenuItems(N2.Parent);
  SetMenuItemBitmap(N2, CutB);
  SetMenuItemBitmap(N1, CopyB);
  SetMenuItemBitmap(N3, PstB);
  SetMenuItemBitmap(N16, SelAllB);
end;

procedure TFRDesignerForm.N37Click(Sender: TObject);
begin // toolbars
  Pan1.Checked := Panel1.IsVisible;
  Pan2.Checked := Panel2.IsVisible;
  Pan3.Checked := Panel3.IsVisible;
  Pan4.Checked := Panel4.IsVisible;
  Pan5.Checked := InspForm.Visible;
  Pan6.Checked := AlignForm.Visible;
end;

procedure TFRDesignerForm.Pan2Click(Sender: TObject);
  procedure SetShow(c: Array of TWinControl; i:Integer; b:Boolean);
  begin
    if c[i] is TfrToolBar then
    with c[i] as TfrToolBar do
    begin
      if IsFloat then
        FloatWindow.Visible := b
      else
      begin
        if b then
          AddToDock(Parent as TfrDock);
        Visible := b;
        (Parent as TfrDock).AdjustBounds;
      end;
    end
    else
      (c[i] as TForm).Visible := b;
  end;
begin // each toolbar
  with Sender as TMenuItem do
  begin
    Checked := not Checked;
    SetShow([Panel1,Panel2,Panel3,Panel4,InspForm,AlignForm],Tag,Checked);
  end;
end;


const
  rsGridShow = 'GridShow';
  rsGridAlign = 'GridAlign';
  rsGridSize = 'GridSize';


procedure TFRDesignerForm.SaveState;
var Ini: TRegIniFile;
    Nm: String;
  procedure DoSaveToolbars(t: Array of TfrToolBar);
  var i: Integer;
  begin
    for i := Low(t) to High(t) do
    begin
      SaveToolbarPosition(t[i]);
      t[i].IsVisible := False;
    end;
  end;

begin
  Ini := TRegIniFile.Create(RegRootKey);
  Nm := rsForm + Name;
  Ini.WriteBool(Nm, rsGridShow, ShowGrid);
  Ini.WriteBool(Nm, rsGridAlign, GridAlign);
  Ini.WriteInteger(Nm, rsGridSize, GridSize);
  Ini.Free;
  DoSaveToolbars([Panel1,Panel2,Panel3,Panel4]);
  SaveFormPosition(InspForm);
  InspForm.Hide;
  SaveFormPosition(AlignForm);
  AlignForm.Hide;
end;

procedure TFRDesignerForm.RestoreState;
var Ini: TRegIniFile;
    Nm: String;
  procedure DoRestoreToolbars(t: Array of TfrToolBar);
  var i: Integer;
  begin
    for i := Low(t) to High(t) do
      RestoreToolbarPosition(t[i]);
  end;

begin
  Ini := TRegIniFile.Create(RegRootKey);
  Nm := rsForm + Name;
  GridSize := Ini.ReadInteger(Nm, rsGridSize, 4);
  GridAlign := Ini.ReadBool(Nm, rsGridAlign, True);
  ShowGrid := Ini.ReadBool(Nm, rsGridShow, True);
  Ini.Free;
  DoRestoreToolbars([Panel1,Panel2,Panel3,Panel4]);
  frDock1.AdjustBounds;
  frDock2.AdjustBounds;
  frDock3.AdjustBounds;
  RestoreFormPosition(InspForm);
  RestoreFormPosition(AlignForm);
end;


procedure TFRDesignerForm.DoDrawText(AMenuItem: TMenuItem; ACanvas: TCanvas;
  const ACaption: string; var Rect: TRect; Selected: Boolean; Flags: Longint);
var
  Text: string;
  R: TRect;
begin
  Text := ACaption;
  if (Flags and DT_CALCRECT <> 0) and ((Text = '') or
    (Text[1] = '&') and (Text[2] = #0)) then Text := Text + ' ';
  with ACanvas do
  begin
    Brush.Style := bsClear;
    if Text = '-' then
    begin
      if Flags and DT_CALCRECT = 0 then
      begin
        R := Rect;
        Inc(R.Top, 4);
        DrawEdge(Handle, R, EDGE_ETCHED, BF_TOP);
      end;
    end
    else
    begin
      if AMenuItem.Default then
        Font.Style := Font.Style + [fsBold];
      if not AMenuItem.Enabled then
      begin
        if not Selected then
        begin
          OffsetRect(Rect, 1, 1);
          Font.Color := clBtnHighlight;
          DrawText(Handle, PChar(Text), Length(Text), Rect, Flags);
          OffsetRect(Rect, -1, -1);
        end;
        if Selected and (ColorToRGB(clHighlight) = ColorToRGB(clBtnShadow)) then
          Font.Color := clBtnHighlight else
          Font.Color := clBtnShadow;
      end;
      DrawText(Handle, PChar(Text), Length(Text), Rect, Flags);
    end;
  end;
end;

procedure TFRDesignerForm.DrawItem(AMenuItem: TMenuItem; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
var
  GlyphRect, SaveRect: TRect;
  Btn: TfrSpeedButton;
  Glyph: TBitmap;
begin
  MaxItemWidth := 0; MaxShortCutWidth := 0;
  with ACanvas do
  begin
    if AMenuItem.Caption <> '-' then
    begin
      FillRect(ARect);
      Btn := FindMenuItem(AMenuItem).Btn;
      GlyphRect := Bounds(ARect.Left + 1, ARect.Top + (ARect.Bottom - ARect.Top - 16) div 2, 16, 16);

      if AMenuItem.Checked then
      begin
        Glyph := TBitmap.Create;
        if AMenuItem.RadioItem then
          Glyph.Handle := LoadBitmap(hInstance, 'BMP_RADIO') else
          Glyph.Handle := LoadBitmap(hInstance, 'BMP_CHECK');
        Draw(GlyphRect.Left, GlyphRect.Top, Glyph);
        Glyph.Free;
      end
      else if Btn <> nil then
      begin
        Glyph := TBitmap.Create;
        Glyph.Width := 16; Glyph.Height := 16;
        Btn.DrawGlyph(Glyph.Canvas, 0, 0, AMenuItem.Enabled);
        BrushCopy(GlyphRect, Glyph, Rect(0,0,16,16), Glyph.TransparentColor);
        Glyph.Free;
      end;
      ARect.Left := GlyphRect.Right + 4;
    end;

    SaveRect := ARect;
    DoDrawText(AMenuItem, ACanvas, AMenuItem.Caption, ARect, Selected,
      DT_EXPANDTABS or DT_SINGLELINE or DT_LEFT or DT_CALCRECT or DT_NOCLIP);
    OffsetRect(ARect,
      0, ((SaveRect.Bottom - SaveRect.Top) - (ARect.Bottom - ARect.Top)) div 2);
    DoDrawText(AMenuItem, ACanvas, AMenuItem.Caption, ARect, Selected,
      DT_EXPANDTABS or DT_SINGLELINE or DT_LEFT);
    if AMenuItem.ShortCut <> 0 then
    begin
      ARect.Left := StrToInt(ItemWidths.Values[AMenuItem.Parent.Name]) + 6;
      ARect.Right := SaveRect.Right;
      DoDrawText(AMenuItem, ACanvas, ShortCutToText(AMenuItem.ShortCut), ARect,
        Selected, DT_LEFT);
    end;
  end;
end;

procedure TFRDesignerForm.MeasureItem(AMenuItem: TMenuItem; ACanvas: TCanvas;
  var AWidth, AHeight: Integer);
var R: TRect;
    w1: Integer;
begin
  FillChar(R, SizeOf(R), 0);
  DoDrawText(AMenuItem, ACanvas, AMenuItem.Caption, R, False,
    DT_LEFT or DT_EXPANDTABS or DT_SINGLELINE or DT_NOCLIP or DT_CALCRECT);
  w1 := R.Right - R.Left + 31;
  if MaxItemWidth < w1 then MaxItemWidth := w1;
  ItemWidths.Values[AMenuItem.Parent.Name] := IntToStr(MaxItemWidth);

  if AMenuItem.ShortCut <> 0 then
  begin
    FillChar(R, SizeOf(R), 0);
    DoDrawText(AMenuItem, ACanvas, ShortCutToText(AMenuItem.ShortCut), R, False,
      DT_LEFT or DT_EXPANDTABS or DT_SINGLELINE or DT_NOCLIP or DT_CALCRECT);
    w1 := R.Right - R.Left + 15;
    if MaxShortCutWidth < w1 then MaxShortCutWidth := w1;
  end;

{$IFDEF Delphi4}
  AWidth := MaxItemWidth;
{$ELSE}
  AWidth := MaxItemWidth + MaxShortCutWidth;
{$ENDIF}
  if AMenuItem.Caption <> '-' then
    AHeight := 19 else
    AHeight := 10;
end;



procedure TFRDesignerForm.WndProc(var Message: TMessage);
var
  MenuItem: TMenuItem;
  Canvas: TCanvas;
  SaveFont: HFONT;
  DC: HDC;

  function GetMenuFont: HFONT;
  var
    NonClientMetrics: TNonClientMetrics;
  begin
    NonClientMetrics.cbSize := sizeof(NonClientMetrics);
    if SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, @NonClientMetrics, 0) then
      Result := CreateFontIndirect(NonClientMetrics.lfMenuFont) else
      Result := GetStockObject(SYSTEM_FONT);
  end;

begin
  case Message.Msg of
    WM_COMMAND:
      if Popup1.DispatchCommand(Message.wParam) then Exit;
    WM_INITMENUPOPUP:
      with TWMInitMenuPopup(Message) do
        if Popup1.DispatchPopup(MenuPopup) then Exit;
    WM_DRAWITEM:
      with PDrawItemStruct(Message.LParam)^ do
      begin
        MenuItem := MainMenu1.FindItem(itemID, fkCommand);
        if MenuItem = nil then
          MenuItem := Popup1.FindItem(itemID, fkCommand);
        if MenuItem <> nil then
        begin
          Canvas := TControlCanvas.Create;
          with Canvas do
          try
            SaveFont := SelectObject(hDC, GetStockObject(SYSTEM_FONT));
            try
              Handle := hDC;
              Font.Handle := GetMenuFont;
              if itemState and ODS_SELECTED <> 0 then
              begin
                Brush.Color := clHighlight;
                Font.Color := clHighlightText
              end
              else
              begin
                Brush.Color := clMenu;
                Font.Color := clMenuText;
              end;
              DrawItem(MenuItem, Canvas, rcItem, itemState and ODS_SELECTED <> 0);
            finally
              Handle := 0;
              if SaveFont <> 0 then SelectObject(hDC, SaveFont);
            end;
          finally
            Canvas.Free;
          end;
          Exit;
        end;
      end;
    WM_MEASUREITEM:
      with PMeasureItemStruct(Message.LParam)^ do
      begin
        MenuItem := MainMenu1.FindItem(itemID, fkCommand);
        if MenuItem = nil then
          MenuItem := Popup1.FindItem(itemID, fkCommand);
        if MenuItem <> nil then
        begin
          DC := GetWindowDC(Handle);
          try
            Canvas := TControlCanvas.Create;
            with Canvas do
            try
              SaveFont := SelectObject(DC, GetStockObject(SYSTEM_FONT));
              try
                Handle := DC;
                Font.Handle := GetMenuFont;
                MeasureItem(MenuItem, Canvas, Integer(itemWidth), Integer(itemHeight));
              finally
                Handle := 0;
                if SaveFont <> 0 then SelectObject(DC, SaveFont);
              end;
            finally
              Canvas.Free;
            end;
          finally
            ReleaseDC(Handle, DC);
          end;
          Exit;
        end;
      end;
  end;
  inherited WndProc(Message);
end;


{----------------------------------------------------------------------------}
function Objects:TList;
begin
  Result := frDesigner.Page.Objects;
end;

procedure DrawHSplitter(Canvas:TCanvas; Rect:TRect);
begin
  with Canvas do
  begin
    Pen.Mode := pmXor;
    Pen.Color := clSilver;
    Pen.Width := 1;
    MoveTo(Rect.Left,Rect.Top);
    LineTo(Rect.Right,Rect.Bottom);
    Pen.Mode := pmCopy;
  end;
end;

procedure DrawFocusRect(Canvas:TCanvas; Rect:TRect);
begin
  with Canvas do
  begin
    Pen.Mode := pmXor;
    Pen.Color := clSilver;
    Pen.Width := 1;
    Pen.Style := psSolid;
    Brush.Style := bsClear;
    Rectangle(Rect.Left,Rect.Top,Rect.Right,Rect.Bottom);
    Pen.Mode := pmCopy;
    Brush.Style := bsSolid;
  end;
end;

procedure frSetGlyph(Color:TColor; sb:TfrSpeedButton; n:Integer);
var b: TBitmap;
    r: TRect;
    i,j: Integer;
begin
  b := TBitmap.Create;
  b.Width := 32;
  b.Height := 16;
  with b.Canvas do
  begin
    r := Rect(n*32,0,n*32+32,16);
    CopyRect(Rect(0,0,32,16),DesignerForm.Image1.Picture.Bitmap.Canvas,r);
    for i := 0 to 32 do
      for j := 0 to 16 do
        if Pixels[i,j] = clRed then
          Pixels[i,j] := Color;
  end;
  sb.Glyph.Assign(b);
  sb.NumGlyphs := 2;
  b.Free;
end;

procedure DrawSelection(t:TfrView);
var px,py: Word;
procedure DrawPoint(x,y:Word);
begin
  Preview.Canvas.MoveTo(x,y);
  Preview.Canvas.LineTo(x,y);
end;
begin
  if t.Selected then
  with t,Preview.Canvas do
  begin
    Pen.Width := 5;
    Pen.Mode := pmXor;
    Pen.Color := clWhite;
    px := x + dx div 2;
    py := y + dy div 2;
    DrawPoint(x,y); DrawPoint(x+dx,y);
    DrawPoint(x,y+dy);
    if Objects.IndexOf(t) = RightBottom then
      Pen.Color := clTeal;
    DrawPoint(x+dx,y+dy);
    Pen.Color := clWhite;
    if SelNum = 1 then
    begin
      DrawPoint(px,y); DrawPoint(px,y+dy);
      DrawPoint(x,py); DrawPoint(x+dx,py);
    end;
    Pen.Mode := pmCopy;
  end;
end;

procedure DrawShape(t:TfrView);
begin
  if t.Selected then
  with t do
    if ShapeMode = smFrame then
      DrawFocusRect(Preview.Canvas,Rect(x,y,x+dx+1,y+dy+1))
    else
    with Preview.Canvas do
    begin
      Pen.Width := 1;
      Pen.Mode := pmNot;
      Brush.Style := bsSolid;
      Rectangle(x,y,x+dx+1,y+dy+1);
      Pen.Mode := pmCopy;
    end;
end;

procedure Draw(N:Integer; ClipRgn:HRGN);
var i: Integer;
    t: TfrView;
    R,R1: HRGN;
  procedure DrawBackground;
  var i,j: Integer;
  begin
    with Preview.Canvas do
    begin
      if DesignerForm.ShowGrid and (DesignerForm.GridSize <> 18) then
      begin
        with GridBitmap.Canvas do
        begin
          Brush.Color := clWhite;
          FillRect(Rect(0,0,8,8));
          Pixels[0,0] := clBlack;
          if DesignerForm.GridSize = 4 then
          begin
            Pixels[4,0] := clBlack;
            Pixels[0,4] := clBlack;
            Pixels[4,4] := clBlack;
          end;
        end;
        Brush.Bitmap := GridBitmap;
      end
      else
      begin
        Brush.Color := clWhite;
        Brush.Style := bsSolid;
      end;
      FillRgn(Handle, R, Brush.Handle);
      if DesignerForm.ShowGrid and (DesignerForm.GridSize = 18) then
      begin
        i := 0;
        while i < Preview.Width do
        begin
          j := 0;
          while j < Preview.Height do
          begin
            if RectVisible(Handle,Rect(i,j,i+1,j+1)) then
              SetPixel(Handle,i,j,clBlack);
            Inc(j,DesignerForm.GridSize);
          end;
          Inc(i,DesignerForm.GridSize);
        end;
      end;
      Brush.Style := bsClear;
      Pen.Width := 1;
      Pen.Color := clGray;
      Pen.Style := psSolid;
      Pen.Mode := pmCopy;
      if frDesigner.Page.UseMargins then
      with frDesigner.Page do
      begin
        with PrnInfo do
          Rectangle(Ofx,Ofy,Pw+Ofx,Ph+Ofy);
        Pen.Style := psDot;
        with pgMargins,PrnInfo do
          if (Left <> 0) or (Right <> 0) or (Top <> 0) or (Bottom <> 0) then
            Rectangle(Left,Top,Pgw-Right,Pgh-Bottom);
      end;
    end;
  end;
  function IsVisible(t:TfrView): Boolean;
  var R: HRGN;
  begin
    R := t.GetClipRgn(rtNormal);
    Result := CombineRgn(R, R, ClipRgn, RGN_AND) <> NULLREGION;
    DeleteObject(R);
  end;

begin
  if DocMode <> dmDesigning then Exit;
  if ClipRgn = 0 then
    with Preview.Canvas.ClipRect do
      ClipRgn := CreateRectRgn(Left, Top, Right, Bottom);

{$IFNDEF Delphi2}
  if frCharset <> DEFAULT_CHARSET then
    Preview.Canvas.Font.Charset := frCharset;
{$ENDIF}

  R := CreateRectRgn(0, 0, Preview.Width, Preview.Height);
  for i := Objects.Count-1 downto 0 do
  begin
    t := Objects[i];
    if i <= N then
      if t.Selected then
        t.Draw(Preview.Canvas)
      else if IsVisible(t) then
      begin
        R1 := CreateRectRgn(0, 0, 1, 1);
        CombineRgn(R1, ClipRgn, R, RGN_AND);
        SelectClipRgn(Preview.Canvas.Handle, R1);
        DeleteObject(R1);
        t.Draw(Preview.Canvas);
      end;
    R1 := t.GetClipRgn(rtNormal);
    CombineRgn(R, R, R1, RGN_DIFF);
    DeleteObject(R1);
    SelectClipRgn(Preview.Canvas.Handle, R);
  end;
  CombineRgn(R, R, ClipRgn, RGN_AND);
  DrawBackground;

  DeleteObject(R);
  DeleteObject(ClipRgn);
  SelectClipRgn(Preview.Canvas.Handle, 0);
  DrawPage(dmSelection);
end;

procedure DrawPage(DrawMode:TDesignerDrawMode);
var i: Integer;
    t: TfrView;
begin
  if DocMode <> dmDesigning then Exit;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    case DrawMode of
      dmAll: t.Draw(Preview.Canvas);
      dmSelection: DrawSelection(t);
      dmShape: DrawShape(t);
    end;
  end;
end;

function frGetTopSelected: Integer;
var i: Integer;
begin
  Result := Objects.Count-1;
  for i := Objects.Count-1 downto 0 do
    if TfrView(Objects[i]).Selected then
    begin
      Result := i;
      break;
    end;
end;

function frCheckBand(b:TfrBandType): Boolean;
var i: Integer;
    t: TfrView;
begin
  Result := False;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Typ = gtBand then
      if b = TfrBandType(t.FrameTyp) then
      begin
        Result := True;
        break;
      end;
  end;
end;

function GetUnusedBand: TfrBandType;
var b: TfrBandType;
begin
  Result := btNone;
  for b := btReportTitle to btNone do
    if not frCheckBand(b) then
    begin
      Result := b;
      break;
    end;
  if Result = btNone then Result := btMasterData;
end;

procedure SendBandsToDown;
var i,j,n,k: Integer;
    t: TfrView;
begin
  n := Objects.Count; j := 0; i := n-1;
  k := 0;
  while j < n do
  begin
    t := Objects[i];
    if t.Typ = gtBand then
    begin
      Objects.Delete(i);
      Objects.Insert(0,t);
      Inc(k);
    end else Dec(i);
    Inc(j);
  end;
  for i := 0 to n-1 do // sends btOverlay to back
  begin
    t := Objects[i];
    if (t.Typ = gtBand) and (t.FrameTyp = Integer(btOverlay)) then
    begin
      Objects.Delete(i);
      Objects.Insert(0,t);
      break;
    end;
  end;
  i := 0; j := 0;
  while j < n do // sends btColumnXXX to front
  begin
    t := Objects[i];
    if (t.Typ = gtBand) and
       (TfrBandType(t.FrameTyp) in [btColumnHeader..btColumnFooter]) then
    begin
      Objects.Delete(i);
      Objects.Insert(k-1,t);
    end
    else Inc(i);
    Inc(j);
  end;
end;

procedure Unselect;
begin
  DesignerForm.Unselect;
end;

procedure ClearClipBoard;
var t: TfrView;
begin
  if Assigned(ClipBd) then
    with ClipBd do
    while Count > 0 do
    begin
      t := Items[0];
      t.Free;
      Delete(0);
    end;
end;

procedure GetRegion;
var i: Integer;
    t: TfrView;
    R: HRGN;
begin
  ClipRgn := CreateRectRgn(0, 0, 0, 0);
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
    begin
      R := t.GetClipRgn(rtExtended);
      CombineRgn(ClipRgn, ClipRgn, R, RGN_OR);
      DeleteObject(R);
    end;
  end;
  FirstChange := False;
end;


initialization
  DesignerForm := TfrDesignerForm.Create(nil);
  ClipBd := TList.Create;
  frDesigner := DesignerForm;

finalization
  DesignerForm.Free;
  ClearClipBoard;
  ClipBd.Free;

end.
