{*******************************************}
{                                           }
{            FastReport v2.2                }
{                                           }
{ Editeur d'expression , Editeur paramtres }
{ (C) Guilbaud Olivier                      }
{        golivier@bigfoot.com               }
{                                           }
{ FastReport :(c) 1998-99 by Tzyganenko A.  }
{                                           }
{ Merci de transmettre vos commantaires &   }
{ modifications                             }
{Ceci est un FREEWARE il peut tre utilis  }
{librement.                                 }
{*******************************************}
{Histo :                                    }
{ 04/06/99 : Cration                       }


unit edExpPar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,FR_Utils;

type
  TedParamFct = class(TSForm)
    Panel1: TPanel;
    hlp1: TLabel;
    Panel2: TPanel;
    hlp2: TMemo;
    pnP1: TPanel;
    Label1: TLabel;
    edX: TEdit;
    Button1: TButton;
    pnP2: TPanel;
    Label2: TLabel;
    edY: TEdit;
    Button2: TButton;
    pnP3: TPanel;
    Label3: TLabel;
    edZ: TEdit;
    Button3: TButton;
    pnBut: TPanel;
    BOk: TBitBtn;
    BitBtn2: TBitBtn;
    Panel5: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edXChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    NbParam : Integer;
    St      : String;
    Function ResultPar : String;
  end;

var
  edParamFct: TedParamFct;

implementation

{$R *.DFM}
Uses edExpr;

Function TedParamFct.ResultPar : String;
begin
  if pnP1.Visible then Result:=edX.Text;
  if pnP2.Visible then Result:=Result+','+edY.Text;
  if pnP3.Visible then Result:=Result+','+edZ.Text;
end;

procedure TedParamFct.Button1Click(Sender: TObject);
Var edexp : TExprEditor;
    edp   : TEdit;
begin
 edP:=NIL;
 If Sender is TButton then
 begin
  Case TButton(Sender).Tag of
   1 : edP:=edX;
   2 : edP:=edY;
   3 : edP:=edZ;
  end;
 end;

 If EdP=NIL then Exit;
 Try
  edExp:=TExprEditor.Create(Self);
  edExp.moExpres.Text:=edP.Text;
  if edExp.ShowModal=mrOk then
  begin
    edP.Text:=edExp.moExpres.Text;
    if assigned(edP.OnChange) then edP.OnChange(NIL);
  end;

 finally
  edExp.free;
 end;
end;

procedure TedParamFct.FormActivate(Sender: TObject);
Var H,I : Integer;
begin
  // Init langue
  LoadLanguageId('ExpresParamEditor');

  // affichage
  Panel2.Visible:=(Hlp2.Text<>'');
  Panel5.Visible:=Panel2.Visible;

  NbParam:=0;
  If Hlp1.Caption<>'' then
  begin
   //Compte le nombre de paramtres
   ST:=Hlp1.Caption;
   While Pos('<',ST)<>0 do
   begin
     inc(NbParam);
     System.Delete(ST,Pos('<',ST),1);
   end;
  end;

  pnP1.Visible:=(NbParam>=1);
  pnP2.Visible:=(NbParam>=2);
  pnP3.Visible:=(NbParam>=3);

  // Rgle la hauteur
  H:=0;
  For i:=0 to ControlCount-1 do
   if Controls[i].Visible then H:=H+Controls[i].Height;

  Height:=H+22;
end;

procedure TedParamFct.edXChange(Sender: TObject);
Var K : Integer;
begin
  K:=0;
  If edX.Text<>'' then Inc(K);
  If edY.Text<>'' then Inc(K);
  If edZ.Text<>'' then Inc(K);

  BOk.Enabled:=(K=NbParam);
end;

end.
