
{*****************************************}
{                                         }
{             FastReport v2.2             }
{              Picture editor             }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_GEdit;

interface

{$I FR_Vers.inc}

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, FR_Utils;

type
  TGEditorForm = class(TSForm)
    Image1: TImage;
    Bevel1: TBevel;
    OpenDlg: TOpenDialog;
    CB1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure CB1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GEditorForm: TGEditorForm;

implementation

{$R *.DFM}

procedure TGEditorForm.BitBtn1Click(Sender: TObject);
begin
  OpenDlg.Filter := frLoadStr('SPictFile') +
    ' (*.bmp *.ico *.wmf *.emf)|*.bmp;*.ico;*.wmf;*.emf|' +
    frLoadStr('SAllFiles') + '|*.*';
  OpenDlg.Title :=frLoadStr('SPictOpenFile');
  if OpenDlg.Execute then
    Image1.Picture.LoadFromFile(OpenDlg.FileName);
end;

procedure TGEditorForm.CB1Click(Sender: TObject);
begin
  Image1.Stretch := CB1.Checked;
end;

procedure TGEditorForm.Button4Click(Sender: TObject);
begin
  Image1.Picture.Assign(nil);
end;

end.
